diff -C3 -r scratch/Configure perl5.004_02/Configure
*** scratch/Configure	Thu Aug  7 16:08:44 1997
--- perl5.004_02/Configure	Tue Sep 16 13:03:54 1997
***************
*** 1768,1773 ****
--- 1768,1775 ----
  			*)	osvers="$3" ;;
  			esac
  			;;
+ 		MiNT)  osname=mint
+ 			;;
  		netbsd*) osname=netbsd 
  			osvers="$3"
  			;;
diff -C3 -r scratch/MANIFEST perl5.004_02/MANIFEST
*** scratch/MANIFEST	Tue Jul 29 02:01:16 1997
--- perl5.004_02/MANIFEST	Sat Sep 27 19:41:52 1997
***************
*** 264,269 ****
--- 264,270 ----
  hints/lynxos.sh		Hints for named architecture
  hints/machten.sh	Hints for named architecture
  hints/machten_2.sh	Hints for named architecture
+ hints/mint.sh		Hints for named architecture
  hints/mips.sh		Hints for named architecture
  hints/mpc.sh		Hints for named architecture
  hints/mpeix.sh		Hints for named architecture
diff -C3 -r scratch/ext/POSIX/POSIX.xs perl5.004_02/ext/POSIX/POSIX.xs
*** scratch/ext/POSIX/POSIX.xs	Tue Aug  5 15:03:00 1997
--- perl5.004_02/ext/POSIX/POSIX.xs	Fri Sep 19 17:36:58 1997
***************
*** 2957,2965 ****
--- 2957,2971 ----
  	    if (lcbuf->thousands_sep && *lcbuf->thousands_sep)
  		hv_store(RETVAL, "thousands_sep", 13,
  		    newSVpv(lcbuf->thousands_sep, 0), 0);
+ #ifndef __MINT__
+ 	/* There's a bug in MiNTLib's locale.h.  The struct locale should
+ 	 * have a (char*) member grouping.  In MiNTLib it's char. :-(
+ 	 * Anyway, it's a do-nothing, so we simply leave it out for now.
+ 	 */
  	    if (lcbuf->grouping && *lcbuf->grouping)
  		hv_store(RETVAL, "grouping", 8,
  		    newSVpv(lcbuf->grouping, 0), 0);
+ #endif
  	    if (lcbuf->int_curr_symbol && *lcbuf->int_curr_symbol)
  		hv_store(RETVAL, "int_curr_symbol", 15,
  		    newSVpv(lcbuf->int_curr_symbol, 0), 0);
***************
*** 2972,2980 ****
--- 2978,2989 ----
  	    if (lcbuf->mon_thousands_sep && *lcbuf->mon_thousands_sep)
  		hv_store(RETVAL, "mon_thousands_sep", 17,
  		    newSVpv(lcbuf->mon_thousands_sep, 0), 0);
+ #ifndef __MINT__
+ 	/* See above.  */
  	    if (lcbuf->mon_grouping && *lcbuf->mon_grouping)
  		hv_store(RETVAL, "mon_grouping", 12,
  		    newSVpv(lcbuf->mon_grouping, 0), 0);
+ #endif
  	    if (lcbuf->positive_sign && *lcbuf->positive_sign)
  		hv_store(RETVAL, "positive_sign", 13,
  		    newSVpv(lcbuf->positive_sign, 0), 0);
Only in perl5.004_02: hints
diff -C3 -r scratch/malloc.c perl5.004_02/malloc.c
*** scratch/malloc.c	Tue Jul 29 00:55:46 1997
--- perl5.004_02/malloc.c	Sat Sep 27 19:35:08 1997
***************
*** 38,44 ****
  #define u_short unsigned short
  
  /* 286 and atarist like big chunks, which gives too much overhead. */
! #if (defined(RCHECK) || defined(I286) || defined(atarist)) && defined(PACK_MALLOC)
  #undef PACK_MALLOC
  #endif 
  
--- 38,44 ----
  #define u_short unsigned short
  
  /* 286 and atarist like big chunks, which gives too much overhead. */
! #if (defined(RCHECK) || defined(I286) || defined(atarist) || defined(__MINT__)) && defined(PACK_MALLOC)
  #undef PACK_MALLOC
  #endif 
  
***************
*** 382,390 ****
  	/*
  	 * Insure memory is allocated
  	 * on a page boundary.  Should
! 	 * make getpageize call?
  	 */
! #ifndef atarist /* on the atari we dont have to worry about this */
    	op = (union overhead *)sbrk(0);
  #  ifndef I286
    	if ((UV)op & (0x7FF >> CHUNK_SHIFT)) {
--- 382,390 ----
  	/*
  	 * Insure memory is allocated
  	 * on a page boundary.  Should
! 	 * make getpagesize call?
  	 */
! #if !defined(atarist) && !defined(__MINT__) /* on the atari we dont have to worry about this */
    	op = (union overhead *)sbrk(0);
  #  ifndef I286
    	if ((UV)op & (0x7FF >> CHUNK_SHIFT)) {
***************
*** 397,405 ****
  #  else
  	/* The sbrk(0) call on the I286 always returns the next segment */
  #  endif
! #endif /* atarist */
  
! #if !(defined(I286) || defined(atarist))
  	/* take 2k unless the block is bigger than that */
    	rnu = (bucket <= 8) ? 11 : bucket + 3;
  #else
--- 397,405 ----
  #  else
  	/* The sbrk(0) call on the I286 always returns the next segment */
  #  endif
! #endif /* atarist && __MINT */
  
! #if !(defined(I286) || defined(atarist) || defined(__MINT__))
  	/* take 2k unless the block is bigger than that */
    	rnu = (bucket <= 8) ? 11 : bucket + 3;
  #else
diff -C3 -r scratch/miniperlmain.c perl5.004_02/miniperlmain.c
*** scratch/miniperlmain.c	Tue Dec 17 19:48:02 1996
--- perl5.004_02/miniperlmain.c	Sat Sep 27 00:27:14 1997
***************
*** 19,24 ****
--- 19,29 ----
  static void xs_init _((void));
  static PerlInterpreter *my_perl;
  
+ #ifdef __MINT__
+ /* Minimum stack size for MiNT.  */
+ long _stksize = 64 * 1024;
+ #endif
+ 
  int
  #ifdef CAN_PROTOTYPE
  main(int argc, char **argv, char **env)
diff -C3 -r scratch/perl.c perl5.004_02/perl.c
*** scratch/perl.c	Tue Aug  5 15:38:36 1997
--- perl5.004_02/perl.c	Sat Sep 27 19:40:16 1997
***************
*** 1752,1758 ****
  	    if (len + 1 + strlen(scriptname) + MAX_EXT_LEN >= sizeof tokenbuf)
  		continue;	/* don't search dir with too-long name */
  	    if (len
! #if defined(atarist) || defined(DOSISH)
  		&& tokenbuf[len - 1] != '/'
  		&& tokenbuf[len - 1] != '\\'
  #endif
--- 1752,1758 ----
  	    if (len + 1 + strlen(scriptname) + MAX_EXT_LEN >= sizeof tokenbuf)
  		continue;	/* don't search dir with too-long name */
  	    if (len
! #if defined(__MINT__) || defined(DOSISH)
  		&& tokenbuf[len - 1] != '/'
  		&& tokenbuf[len - 1] != '\\'
  #endif
diff -C3 -r scratch/pp_sys.c perl5.004_02/pp_sys.c
*** scratch/pp_sys.c	Sat Sep 27 19:26:04 1997
--- perl5.004_02/pp_sys.c	Sat Sep 27 20:00:18 1997
***************
*** 462,469 ****
      if (!(io = GvIO(gv)) || !(fp = IoIFP(io)))
  	RETPUSHUNDEF;
  
! #ifdef DOSISH
! #ifdef atarist
      if (!PerlIO_flush(fp) && (fp->_flag |= _IOBIN))
  	RETPUSHYES;
      else
--- 462,469 ----
      if (!(io = GvIO(gv)) || !(fp = IoIFP(io)))
  	RETPUSHUNDEF;
  
! #if defined(DOSISH) || defined(__MINT__)
! #if defined(atarist) || defined(__MINT__)
      if (!PerlIO_flush(fp) && (fp->_flag |= _IOBIN))
  	RETPUSHYES;
      else
diff -C3 -r scratch/t/io/fs.t perl5.004_02/t/io/fs.t
*** scratch/t/io/fs.t	Thu Apr 10 16:24:12 1997
--- perl5.004_02/t/io/fs.t	Sat Sep 27 00:39:50 1997
***************
*** 70,81 ****
  ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,
      $blksize,$blocks) = stat('a');
  if ($ino == 0) {print "ok 15\n";} else {print "not ok 15\n";}
! $foo = (utime 500000000,500000001,'b');
  if ($foo == 1) {print "ok 16\n";} else {print "not ok 16 $foo\n";}
  ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,
      $blksize,$blocks) = stat('b');
  if ($ino) {print "ok 17\n";} else {print "not ok 17\n";}
! if (($atime == 500000000 && $mtime == 500000001)
  	|| $wd =~ m#/afs/# || $^O eq 'amigaos')
      {print "ok 18\n";}
  else
--- 70,84 ----
  ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,
      $blksize,$blocks) = stat('a');
  if ($ino == 0) {print "ok 15\n";} else {print "not ok 15\n";}
! # On the Atari file timestamps are always rounded down to even numbers.
! # Does anybody mind taking 500000002 instead of 500000001?
! # $foo = (utime 500000000,500000002,'b');
! $foo = (utime 500000000,500000002,'b');
  if ($foo == 1) {print "ok 16\n";} else {print "not ok 16 $foo\n";}
  ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,
      $blksize,$blocks) = stat('b');
  if ($ino) {print "ok 17\n";} else {print "not ok 17\n";}
! if (($atime == 500000000 && $mtime == 500000002)
  	|| $wd =~ m#/afs/# || $^O eq 'amigaos')
      {print "ok 18\n";}
  else
diff -C3 -r scratch/t/lib/safe2.t perl5.004_02/t/lib/safe2.t
*** scratch/t/lib/safe2.t	Sat Jun  7 03:35:52 1997
--- perl5.004_02/t/lib/safe2.t	Sat Sep 27 17:32:02 1997
***************
*** 123,129 ****
  $cpt->rdo('/non/existant/file.name');
  print +(($! =~ /No such file/ || $! =~ /file specification syntax error/) ||
        $! =~ /A file or directory in the path name does not exist/ ||
!       $! =~ /Device not configured/ ?
        "ok $t\n" : "not ok $t # $!\n"); $t++;
  print 1 ? "ok $t\n" : "not ok $t\n#$@/$!\n"; $t++;
    
--- 123,130 ----
  $cpt->rdo('/non/existant/file.name');
  print +(($! =~ /No such file/ || $! =~ /file specification syntax error/) ||
        $! =~ /A file or directory in the path name does not exist/ ||
!       $! =~ /Device not configured/ ||
!       $! =~ /file not found/ ?
        "ok $t\n" : "not ok $t # $!\n"); $t++;
  print 1 ? "ok $t\n" : "not ok $t\n#$@/$!\n"; $t++;
    
diff -C3 -r scratch/t/op/mkdir.t perl5.004_02/t/op/mkdir.t
*** scratch/t/op/mkdir.t	Sat Jun  7 03:35:52 1997
--- perl5.004_02/t/op/mkdir.t	Sat Sep 20 04:28:24 1997
***************
*** 15,18 ****
  print (-d 'blurfl' ? "ok 4\n" : "not ok 4\n");
  print (rmdir('blurfl') ? "ok 5\n" : "not ok 5\n");
  print (rmdir('blurfl') ? "not ok 6\n" : "ok 6\n");
! print ($! =~ /such|exist/ ? "ok 7\n" : "not ok 7\n");
--- 15,18 ----
  print (-d 'blurfl' ? "ok 4\n" : "not ok 4\n");
  print (rmdir('blurfl') ? "ok 5\n" : "not ok 5\n");
  print (rmdir('blurfl') ? "not ok 6\n" : "ok 6\n");
! print ($! =~ /such|exist|not found/ ? "ok 7\n" : "not ok 7\n");
diff -C3 -r scratch/t/op/taint.t perl5.004_02/t/op/taint.t
*** scratch/t/op/taint.t	Fri Jun 13 16:14:48 1997
--- perl5.004_02/t/op/taint.t	Sat Sep 20 04:41:46 1997
***************
*** 348,355 ****
      unlink $filename;	# in any case
  
      test 65, eval { open FOO, $foo } eq '', 'open for read';
      test 66, $@ eq '', $@;		# NB: This should be allowed
!     test 67, $! == 2;			# File not found
  
      test 68, eval { open FOO, "> $foo" } eq '', 'open for write';
      test 69, $@ =~ /^Insecure dependency/, $@;
--- 348,359 ----
      unlink $filename;	# in any case
  
      test 65, eval { open FOO, $foo } eq '', 'open for read';
+     my $file_not_found = 2;
+     if ($^O eq 'mint') {		# Actually for test 67
+     	$file_not_found = 33;
+     } 
      test 66, $@ eq '', $@;		# NB: This should be allowed
!     test 67, $! == $file_not_found;	# File not found
  
      test 68, eval { open FOO, "> $foo" } eq '', 'open for write';
      test 69, $@ =~ /^Insecure dependency/, $@;
